<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 30.40</title>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="30.40.css">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>

<body style="background-color: black;">
    <div class="Carveli-contact-US">
        <div class="row form-0">
            <div class="col-md-7 form-1">
                <h2 class="h2">Contact Us </h2>
                <form class="form-3" id="submit">
                    <div class="form-group">
                        <input type="text" class="form-control border-0 text" id="exampleInputName1" placeholder="Name">
                    </div>
                    <div class="form-group">
                        <input type="email" class="form-control border-0 text" id="exampleInputEmail1"
                            aria-describedby="emailHelp" placeholder="Email">
                    </div>
                    <div class="form-group">
                        <textarea class="form-control border-0 text" id="exampleFormControlTextarea1"
                            placeholder="Write something..." rows="3"></textarea>
                    </div>
                    <button type="submit" class="btn btn-light btn-lg d-block"
                        style="margin: auto; font-weight: 700;">Submit</button>
                </form>
            </div>
            <div class="col-md-5 form-2">
                <h1 class="h1">CARVELI</h1>
            </div>
        </div>
    </div>
</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";

    var gSubmitFormElement = document.getElementById("submit");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gSubmitFormElement.addEventListener("submit", function (paramEvent) {
        paramEvent.preventDefault();
        submit();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function submit() {
        //khai báo đối tượng
        var vPersonObj = {
            name: "",
            email: "",
            message: ""
        };
        //B1: thu thập dữ liệu
        thuThapDuLieu(vPersonObj);
        //B2: kiểm tra dữ liệu
        var vDuLieuHopLe = validateData(vPersonObj);
        if (vDuLieuHopLe) {
            //B3: gọi API
            callAPI(vPersonObj);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dũ liêu
    function thuThapDuLieu(paramPersonObj) {
        var vNameInput = document.getElementById("exampleInputName1");
        var vEmailInput = document.getElementById("exampleInputEmail1");
        var vMessageInput = document.getElementById("exampleFormControlTextarea1");

        paramPersonObj.name = vNameInput.value.trim();
        paramPersonObj.email = vEmailInput.value.trim();
        paramPersonObj.message = vMessageInput.value.trim();
    }

    //hàm kiểm tra dữ liệu
    function validateData(paramPersonObj) {
        if (paramPersonObj.name === "") {
            alert("Name không được để trống");
            return false;
        }
        if (!paramPersonObj.email.includes("@")) {
            alert("Email không đúng định dạng");
            return false;
        }
        if (paramPersonObj.message === "") {
            alert("Vui lòng nhập vào message");
            return false;
        }
        return true;
    }

    //call API function
    function callAPI(paramPersonObj) {
        var vQueryParam = new URLSearchParams(paramPersonObj);
        //chuẩn bị gọi api
        var vXmlHttpLogin = new XMLHttpRequest();
        vXmlHttpLogin.open("GET", gBASE_URL + "?" + vQueryParam.toString(), true);
        vXmlHttpLogin.send();
        vXmlHttpLogin.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginResponseText = vXmlHttpLogin.responseText
                    var vLoginInfo = JSON.parse(vLoginResponseText);
                    console.log(vLoginInfo)
                    if (vLoginInfo.length > 0) {
                        alert("Yêu cầu thành công");
                    }
                    else {
                        alert("yêu cầu không thành công");
                    }
                }
            }
    }
</script>

</html>